UseMB=0		; Print Str$(MyReal8) works only in MB
MagicXor =	0*815D32ECh
if UseMB
	include \masm32\MasmBasic\MasmBasic.inc
else
	include \masm32\include\masm32rt.inc
endif
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

fCmpFpu	PROTO: DWORD, :DWORD, :DWORD, :DWORD
fCmpFpu2	PROTO: DWORD, :DWORD, :DWORD, :DWORD
fCmpXmm	PROTO: DWORD, :DWORD, :DWORD, :DWORD
fMinMax	PROTO: DWORD, :DWORD, :DWORD, :DWORD
fMinMax1	PROTO: DWORD, :DWORD, :DWORD, :DWORD

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.data
fpMin	REAL8 ?
fpMax	REAL8 ?
fpMin2	REAL8 ?
fpMax2	REAL8 ?
R8	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, -7654321.0
	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, -7654321.0
	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, -7654321.0
	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.24e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.24e3, -7654321.0

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	200000	; One Mio would be a typical value
	Magic = -7654321
	finit
	if UseMB
			invoke fCmpFpu, offset R8, 8*16, offset fpMin, offset fpMax
			Print Str$("The min is %f\n", fpMin)
			Print Str$("The max is %f\n\n", fpMax)

			invoke fCmpFpu2, offset R8, 8*16, offset fpMin, offset fpMax
			Print Str$("The min is %f\n", fpMin)
			Print Str$("The max is %f\n\n", fpMax)

			invoke fCmpXmm, offset R8, 8*16, offset fpMin2, offset fpMax2
			Print Str$("The min is %f\n", fpMin2)
			Print Str$("The max is %f\n\n", fpMax2)

			invoke fMinMax, offset R8, 8*16, offset fpMin2, offset fpMax2
			Print Str$("The min is %f\n", fpMin2)
			Print Str$("The max is %f\n\n", fpMax2)

			invoke fMinMax1, offset R8, 8*16, offset fpMin2, offset fpMax2
			Print Str$("The min is %f\n", fpMin2)
			Print Str$("The max is %f\n\n", fpMax2)
	endif
	REPEAT 3
		invoke Sleep, SleepMs
		finit
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fCmpFpu, offset R8, 8*16, offset fpMin, offset fpMax
		counter_end
;		shr eax, 7	; uncomment to get cycles per REAL8
		print str$(eax), 9, "cycles for fCmpFpu  (fcomi)", 13, 10
		invoke Sleep, SleepMs
		finit
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fCmpFpu2, offset R8, 8*16, offset fpMin, offset fpMax
		counter_end
;		shr eax, 7	; uncomment to get cycles per REAL8
		print str$(eax), 9, "cycles for fCmpFpu2 (fcom)", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fCmpXmm, offset R8, 8*16, offset fpMin, offset fpMax
		counter_end
		print str$(eax), 9, "cycles for fCmpXmm  (comisd)", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fMinMax, offset R8, 8*16, offset fpMin, offset fpMax
		counter_end
		print str$(eax), 9, "cycles for fMinMax  (minsd)", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fMinMax1, offset R8, 8*16, offset fpMin, offset fpMax
		counter_end
		print str$(eax), 9, "cycles for fMinMax1 (minsd)", 13, 10, 10
	ENDM
	CodeSize fCmpFpu
	CodeSize fCmpFpu2
	CodeSize fCmpXmm
	CodeSize fMinMax
	CodeSize fMinMax1
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

;     C3     C2     C1     C0     Meaning
;     0      0      ?      0      ST > source
;     0      0      ?      1      ST < source
;     1      0      ?      0      ST = source
;     1      1      ?      1      ST not comparable to source
fCmpFpu_s:
fpHigh	REAL8 99.99e99
fCmpFpu proc uses ecx arrStart, arrSize, ptrMin, ptrMax
	mov edx, arrStart
	mov ecx, arrSize
	ffree st(7)
	fld fpHigh
	ffree st(7)
	fld st
	fchs
	.Repeat
		if MagicXor
				mov eax, [edx]
				xor eax, [edx+4]
				cmp eax, MagicXor	; xor'ed magic
				je @F
		endif
		fld REAL8 ptr [edx]	; load array value
		fld st
;	int 3	; Opt_Olly 2
		fcomi st, st(2)
		.if !Carry?
				fxch st(2)
			.endif
			fstp st
		fcomi st, st(2)
		.if Carry?
				fxch st(2)
			.endif
			fstp st
	@@:	add edx, 8
		dec ecx
	.Until Sign?
	fstp fpMax
	fstp fpMin
	ret
fCmpFpu endp
fCmpFpu_endp:

fCmpFpu2_s:
fpHigh2	REAL8 99.99e99
fCmpFpu2 proc uses ecx arrStart, arrSize, ptrMin, ptrMax
	mov edx, arrStart
	mov ecx, arrSize
	ffree st(7)
	fld fpHigh2
	ffree st(7)
	fld st
	fchs
;	int 3	; Opt_Olly 2
	.Repeat
		if MagicXor
				mov eax, [edx]
				xor eax, [edx+4]
				cmp eax, MagicXor	; xor'ed magic
				je @F
		endif
		fcom REAL8 ptr [edx]
		fnstsw ax	; C0=8, C1=9, C2=10, C3=14
		test ah, 1
		.if !Zero?
				fstp st
				fld REAL8 ptr [edx]
			.endif
		fxch
		fcom REAL8 ptr [edx]
		fnstsw ax
		test ah, 1
		.if Zero?
				fstp st
				fld REAL8 ptr [edx]
			.endif
		fxch
	@@:	add edx, 8
		dec ecx
	.Until Sign?
	fstp fpMax
	fstp fpMin
	ret
fCmpFpu2 endp
fCmpFpu2_endp:

fCmpXmm_s:
fpHighX	REAL8 1.79e308
fCmpXmm proc uses ecx arrStart, arrSize, ptrMin, ptrMax
	mov edx, arrStart
	mov ecx, arrSize
	movups xmm2, oword ptr fpHighX
	xorps xmm3, xmm3
	subsd xmm3, xmm2
;	int 3	; OPT_Olly 2
	.Repeat
		if MagicXor
				mov eax, [edx]
				xor eax, [edx+4]
				cmp eax, MagicXor	; xor'ed magic
				je @F
		endif
		comisd xmm2, REAL8 ptr [edx]
		.if !Carry?
				movlpd xmm2, REAL8 ptr [edx]
			.endif
		comisd xmm3, REAL8 ptr [edx]
		.if Carry?
				movlpd xmm3, REAL8 ptr [edx]
			.endif
	@@:	add edx, 8
		dec ecx
	.Until Sign?
	mov eax, ptrMin
	movlpd REAL8 ptr [eax], xmm2
	mov eax, ptrMax
	movlpd REAL8 ptr [eax], xmm3
	ret
fCmpXmm endp
fCmpXmm_endp:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
fMinMax_s:
fMinMaxHigh	dd 7fefdcf1h
fMinMax proc arrStart, arrSize, ptrMin, ptrMax
	mov edx, [esp+8]	; arrSize
	mov eax, [esp+4]	; arrStart
	movsd xmm0, qword ptr fMinMaxHigh-4	; about 1.79e308
	xorps xmm1, xmm1
	subsd xmm1, xmm0
	.Repeat
		if MagicXor
				cmp dword ptr [eax+4], 0C15D32ECh	; foolproof
				jne @F
				cmp dword ptr [eax], 40000000h
				je fmIgnore
			@@:
		endif
		minsd xmm0, REAL8 ptr [eax]
		maxsd xmm1, REAL8 ptr [eax]
fmIgnore:		add eax, 8
		dec edx
	.Until Sign?
	mov eax, [esp+12]	; ptrMin
	movsd REAL8 ptr [eax], xmm0
	mov eax, [esp+16]	; ptrMax
	movsd REAL8 ptr [eax], xmm1
	ret 16
fMinMax endp
fMinMax_endp:

fMinMax1_s:
fMinMaxHigh1	REAL8 1.79e308
fMinMax1 proc uses ecx arrStart, arrSize, ptrMin, ptrMax
	push ecx
	mov edx, [esp+8]	; arrStart
	mov ecx, [esp+12]	; arrSize
	movlpd xmm0, fMinMaxHigh1
	xorps xmm1, xmm1
	subsd xmm1, xmm0
;	int 3	; OPT_Olly 2
	.Repeat
		if MagicXor
				mov eax, [edx]
				xor eax, [edx+4]
				cmp eax, MagicXor		; xor'ed magic number
				je @F
		endif
		minsd xmm0, REAL8 ptr [edx]
		maxsd xmm1, REAL8 ptr [edx]
	@@:	add edx, 8
		dec ecx
	.Until Sign?
	mov eax, [esp+16]	; ptrMin
	movlpd REAL8 ptr [eax], xmm0
	mov eax, [esp+20]	; ptrMax
	movlpd REAL8 ptr [eax], xmm1
	pop ecx
	ret 16
fMinMax1 endp
fMinMax1_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Timings:
Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
The min is -1240.000
The max is 1240.000

The min is -1240.000
The max is 1240.000

The min is -1240.000
The max is 1240.000

5307    cycles for fCmpFpu
4366    cycles for fCmpXmm
1786    cycles for fMinMax

4970    cycles for fCmpFpu
4239    cycles for fCmpXmm
1776    cycles for fMinMax

97       bytes for fCmpFpu
89       bytes for fCmpXmm
78       bytes for fMinMax

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
1152    cycles for fCmpFpu  (fcomi)
1726    cycles for fCmpFpu2 (fcom)
1162    cycles for fCmpXmm  (comisd)
725     cycles for fMinMax  (minsd)
720     cycles for fMinMax1 (minsd)

1327    cycles for fCmpFpu  (fcomi)
1726    cycles for fCmpFpu2 (fcom)
1157    cycles for fCmpXmm  (comisd)
731     cycles for fMinMax  (minsd)
738     cycles for fMinMax1 (minsd)

1327    cycles for fCmpFpu  (fcomi)
1726    cycles for fCmpFpu2 (fcom)
1162    cycles for fCmpXmm  (comisd)
725     cycles for fMinMax  (minsd)
720     cycles for fMinMax1 (minsd)

75       bytes for fCmpFpu
85       bytes for fCmpFpu2
77       bytes for fCmpXmm
60       bytes for fMinMax
66       bytes for fMinMax1